/* This is a header file for cepstr module */
/* It implements operations on cepstral coefficients */
/* by P.P and J.K. */


/* Calculate a coefs from real input signal of the length WLEN */

#define CEPWLEN 256 /* windows length - it must correspond to that of a caller */
#define CEPN 10  /* number of cepstral coefficients excluding a[0]=1 */



int burg( float *x, float *a, float *alfa) ;

/* Calculate cepstral coefs from a's */
void a2c(float *a,float *c,float alpha) ;

/* To an array of len WLEN, set Hanning window coefs suitable for windowing
   with half overlapping */
void initaceps(float *han) ;

/* Calculate cepstral distance between two c coefs. Ignores c0. */
int de( float *c1, float *c2, float *D2) ;

#ifndef PI
 #define PI (3.14159265358979)
#endif
