function g=a2s(a,N)
% Calculates amplitude spectrum of the length N for a given AR system
% The result should be the same as if an fft were taken from the output 
% of the system when fed with white noise of unit dispersion
% Usage: g=a2s(a,N) 

n=length(a) ;
%denr=[1 -a] ;
%denr=denr(n+1:-1:1) ;
%f=linspace(0,2*pi,N) ;
%g=zeros(1,N) ;
%for k=1:N,
%  z=exp(-i*f(k)) ;
%  g(k)=abs(1/polyval(denr,z)) ;
%end ;

% a faster method is usually (depending on n) to use FFT

g=abs(fft([1 -a zeros(1,N-n-1)])) ;
% here divide by zero could have happened (if we were not cautious)
g=1./max([g ; 1e-30*ones(1,N)]) ;

% Scaling is necessary so that the output matches the fft command
g=g*sqrt(N) ;
