function [ A, C, Q, r]=ard2tm(as,bs,an,bn) 
% Given the AR generators for signal (as,bs) and noise (an,bn),
% this routine generates the appropriate state-space model to be used
% for Kalman filtering by kalman*
% Usage: [A C Q r]=ard2tm(as,bs,an,bn)

ns=length(as) ;
nn=length(an) ;
n=ns+nn ;

A=zeros(n) ; % system transfer matrix
Q=zeros(n) ; % covariance matrix

C=[zeros(1,nn-1) 1 zeros(1,ns-1) 1] ; % output matrix (vector, actually)

A(1:nn,1:nn)=ar2tm(an) ;
A(nn+1:n,nn+1:n)=ar2tm(as) ;

Q(nn,nn)=bn^2 ;
Q(n,n)=bs^2 ;

r=trace(Q)/1000 ; % rather heuristic setting
