function [ A, C, Q, r, P]=ard2tme(as,bs,cs,an,bn,cn) 
% Given the AR generators for signal (as,bs), noise (an,bn), as well as the
% autocorrelations (cs,cn)
% this routine generates the appropriate state-space model to be used
% for Kalman filtering by kalmanrsi
% Usage: [A C Q r P]=ard2tme(as,bs,cs,an,bn,cn)

ns=length(as) ;
nn=length(an) ;
n=ns+nn ;

A=zeros(n) ; % system transfer matrix
Q=zeros(n) ; % system noise covariance matrix
P=zeros(n) ; % initial state estimate covariance matrix

C=[zeros(1,nn-1) 1 zeros(1,ns-1) 1] ; % output matrix (vector, actually)

A(1:nn,1:nn)=ar2tm(an) ;
A(nn+1:n,nn+1:n)=ar2tm(as) ;

Q(nn,nn)=bn^2 ;
Q(n,n)=bs^2 ;

% r=trace(Q)*1e-6 ; % rather heuristic setting
r=1e-6 ;

P(1:nn,1:nn)=c2R(cn(1:nn)) ;
P(nn+1:n,nn+1:n)=c2R(cs(1:ns)) ;