function y=arkalmr(z,r,n) ; 
% This function takes the corrupted signal z=signal+noise, and noise
% covariance. Noise is assumed to be white, Gaussian, with covariance r.
% Estimate y of the signal using repetitive bidirectional nonstationary 
% Kalman filter.  n is the model order.
% Usage: y=arkalmr(z,r,[n]) ;

if nargin<3, n=4 ; end ;

maxrpt=50 ; % maximum number of repetitions
minrpt=2 ;   % minimum number of repetitions
i=0 ; 
y=z ;
lastte=0 ;
T=length(z) ;
lng=min(T,256) ;

while i<maxrpt,
  % cs=corrs(y,lng) ;
  % cs=cs(1:lng/2) ;
  % as=burg1(y,n) ;
  % cr=a2c(as,lng/2) ;
  % bs=sqrt(cr(2:lng/2)\cs(2:lng/2)) ;
  % g=1./abs(fft([1 -as zeros(1,lng-n-1)])) ; % spectrum of the AR system
  % g=(g.^2)*lng ;
  % s=(abs(fft(y))).^2 ;
  % g=g-ones(1,lng)*sum(g)/lng ;
  % s=s-ones(1,lng)*sum(s)/lng ; % detrend
  % bs=sqrt(s/g) 
  % bs3=sqrt(sum(s.*g)/sum(g.*g)) ;
  [as bs]=idarxb(y,n) ;
  yp=y ;
  [y te]=arkalm(z,as,bs,r) ; 
  if i>0 & te>lastte & i>minrpt,
    i=maxrpt ; % getting worse -> finish
  end ;	
  lastte=te ;
  i=i+1 ;
end ;
y=yp ;
