function ys=arxkalm(y,a,q)
% Perform Kalman filter for ARX model and known parameters a
% q is the noise covariance and P the initial covariance matrix
% estimate

n=size(a,2) ; T=size(y,2) ;
ys=zeros(1,T) ;
ys(1:n+1)=y(1:n+1) ;

A=zeros(n+1) ;
A(1,1:n)=a ;
for i=2:n+1, A(i,i-1)=1 ; end ;

P=eye(n+1)*q ;

x=zeros(n+1,1) ;
for i=1:n, x(n+2-i)=y(i) ; end ;

% the first time step
x=A*x ;

for i=n+1:T,
   % store the estimate
   ys(i)=x(1) ;
   % make the data step
   x=x+P(:,1)/P(1,1)*(y(i)-x(1)) ;
   % perform the time step
   x=A*x ;
   P=A*(P-P(:,1)*P(1,:)/P(1,1))*A' ;
   P(1,1)=P(1,1)+q ;
   end ;
end ;


