function anew=astab(aold) ;
% Given parameters of AR filter, stabilize them if necessary by moving them
% inside the unit circle
% Usage: anew=astab(aold)

r=roots([1 -aold]) ;
mr=max(abs(r)) ;
limit=1-1e-3 ;

if mr>=limit,   % not stable
  
  n=length(aold) ;
  r=limit * (r / mr) ;
  anew=real(poly(r)) ;
  anew=-anew(2:n+1)/anew(1) ;  % normalize

else        % do not do anything for stable filters

  anew=aold ;

end ;
