function a=c2a(c,n) 
% Given an autocorrelation function c, this function computes the 'a'
% parameters of an AR synthetising filter of the order n
% It uses the autocorrelation method
% c should begin with autocorrelation at lag 0
% Usage: a=c2a(c,n)

c=c(:) ;
% The length of the input vector
T=length(c) ;
if (2*n>=T), error('The signal is too short.') ; end ;


% Arrange the coefficients into a matrix
C=zeros(n) ;
for i=1:n, for j=1:n, 
  C(j,i)=c(1+abs(j-i)) ; 
end ; end ;

% Compute the AR model parameters
a=(C\c(2:1+n))' ;
 




