function s=c2ps(c,n)
% Calculates power spectrum (square of the amplitude spectrum) 
% of the length n from the correlation function
% Usage: s=c2ps(c,n)

c=c(:)' ;     % make it a row
m=length(c) ;
c=[c zeros(1,n/2-m)] ;
c=[c c(n/2:-1:1)] ;
s=real(ifft(c))*n*n ; % to be consistent with the scaling of fft
s=max([s ; zeros(1,n)]) ; % half wave rectification

