function y=chshape(x,n);

%Function CHSHAPE: Matrix reorganization for multichannel signals.
%
%Usage: y=chshape(x,n);
%  x      - vector with all data
%  n      - number of signal channels
%
%Output:
%  y      - reorganized signal matrix (format as follows)
%             s1(1),   s2(1),  ...,  sn(1),
%             s1(2),   s2(2),  ...,  sn(2),
%             s1(3),   s2(3),  ...,  sn(3),
%               :        :      :      : 
%             1-st.,   2-nd.,   :    n-th channel
 
x=x';
x=x(:);
y=reshape(x,n,length(x)/n);
y=y';


