function c=corri(y,n)
% Computes the first n coefficients of the autocorrelation
% function of the system with reciprocal spectrum to signal y
% It is used to design whitening filter for y
% c(1) is the correlation at lag 0, c(2) at lag 1 etc.
% The correlation is estimated using FFT

N=length(y) ;

if N<n,
       error('Signal too short.') ;
end ;

c=(1 ./ abs(fft(y)).^2 ) / N  ;
c=real(ifft(c)) ;

c=c(1:n)' ;





















