function c=corrn(y,n)
% Computes the first n coefficients of the autocorellation
% function of the signal y
% c(1) is the correllation at lag 0, c(2) at lag 1 etc.
% The correlation is biased, as Mehra claims it gives better results
% for the identification

N=length(y) ;
c=zeros(n,1) ;

for i=1:n,
  c(i)=sum(y(1:N-i+1).*y(i:N))/N ;
end ;