function c=corrss(y,n,w,s)
% Computes the first n coefficients of the autocorrelation
% function of the signal y
% It uses smoothed estimate of the periodograms of length w
% with shift s
% c(1) is the correlation at lag 0, c(2) at lag 1 etc.
% The correlation is estimated using FFT
% Usage: c=corrss(y,n,w,s)

N=length(y) ;
cnt=floor((N-w)/s) ;
h=hanning1(w) ;
h=h * w / sum(h) ; % Compensate for the bias
ss=zeros(1,w) ;
for i=0:cnt,
  ss=ss+abs(fft(y(i*s+1:i*s+w))).^2 ;
end ;

c=real(ifft(ss/((cnt+1)*w))) ;

c=c(1:n)' ;





















