function c=corrw(y,n)
% Computes the first n coefficients of the autocorrelation
% function of the signal y
% c(1) is the correlation at lag 0, c(2) at lag 1 etc.
% The correlation is unbiased and is estimate using FFT
% Here we change the time scale to use the efficient 2^N base FFT
% but there is no point in doing this in MATLAB as it is too slow.

N=length(y) ;

fftsize=2^ceil(log(N)/log(2)) ;
% ifftsize=2^ceil(log(n)/log(2)) ;

q=zeros(1,fftsize) ;
% Linearly expand y->q
for i=1:fftsize,
  u=1+(i-1)/(fftsize-1)*(N-1) ;
  l=min(floor(u),N-1) ; r=l+1 ; 
  q(i)=(r-u)*y(l)+(u-l)*y(r) ;
end ;

c=abs(fft(q)).^2 / fftsize  ;
c=real(ifft(c)) ;

% here we should contract the data again
for i=1:n,
  u=1+(i-1)/(N-1)*(fftsize-1) ;
  l=min(floor(u),fftsize-1) ; r=l+1 ; 
  q(i)=(r-u)*c(l)+(u-l)*c(r) ;
end ;

c=q(1:n)' ;





















