function y=darkalm1(z,as,bs,cs,an,bn,cn) ;
% This function takes the corrupted signal z=signal+noise,
% AR parameters of signal (as,bs) and noise (an,bn)
% and signal resp. noise autocorrelations (cs,cn) and produces the smoothed
% estimate y of signal using bidirectional *stationary* Kalman filter

% it is optimized for AR models but not with respect to Matlab
% but rather with respect to the number of operations
% constant Kalman gain

[A,C,Q,r,P]=ard2tme(as,bs,cs,an,bn,cn) ;

ns=length(as) ;
nn=length(an) ;
n=length(A) ;
T=length(z) ;

% initial uninformative guess
x=zeros(n,1) ;
xf=zeros(n,T) ;
PfA=zeros(n,n) ;
xp=zeros(n,T) ;
F=zeros(n,n) ;
y=zeros(1,n) ;

% Forward run
for i=1:T,
L=P*C' / (C*P*C'+r) ;
P=P-L*C*P ;
 PfA=P*A' ;
 P=A*PfA+Q ;
end ;

L=P*C' / (C*P*C'+r) ;

F=PfA/P ;

for i=1:T,
 e=z(i)-(x(nn)+x(n)) ;          % prediction error
 x=x+L*e ;             % correct the state estimate
 xf(:,i)=x ;              % filtered estimate
 x=A*x ;
 xp(:,i)=x ;              % predicted estimate
 y(i)=x(n) ;
end ;

% Backward run
xl=x ;
for i=T:-1:1,
 x=xf(:,i)+F*(xl-xp(:,i)) ;
 xl=x ;
 y(i)=x(n) ;
end ;





