disp('This file demonstrates the Kalman filtering') ;
disp('Let us first generate the signals, two sinusoids in white noise') ;

T=256 ;
t=1:T ;
x1=sin(2*pi/50*t) ;
x2=sin(2*pi/30*t) ;
r=0.5 ;
y=x1+x2+r*randn(1,T) ;

disp('Here is how the signal looks like. Press any key') ;
figure(2) ; plot([x1' x2']) ; title('The two components') ;
legend('x1','x2') ;
figure(1) ; plot([x1'+x2' y']) ;
title('Signal') ; legend('x1+x2','x1+x2+noise') ;
pause ;

disp('Estimate AR parameters of the two sinusoids:') ;
s1=abs(fft(x1)) ;
s2=abs(fft(x2)) ;

[a1 b1]=s2a(s1,2) 
[a2 b2]=s2a(s2,2)
% Assure the stability, just in case
% a1=astab(a1) ; a2=astab(a2) ;

disp('Apply Kalman filter') ;
[A,C,Q,r1]=ard2tm(a1,b1,a2,b2) ;
z=kalmanrs(y,A,C,Q,r*r) ;

disp('Show the filtered signals compared with originals') ;
plot([x1' z(:,4)]) ; title('Signal 1') ;
legend('Original','Filter output') ;
figure(2) ;
plot([x2' z(:,2)]) ; title('Signal 2') ;
legend('Original','Filter output') ;
% disp('Press any key') ;
% pause ;