disp('Demonstrate Kalman filtering of a speech segment') ;
load spsig4 ;

k=5 ;
ns2=k*ns2 ;
ns=16 ; nn=16 ;
xm2=ns2+sp2 ;
figure(1) ; plot(sp2) ; title('Speech') ;
zoom on ;
figure(2) ; plot(ns2) ; title('Noise') ;
zoom on ;
figure(3) ; plot(xm2) ; title('Noise+Speech') ;
zoom on ;

disp('Press any key') ;
pause ;
ssp2=sfft(sp2,256,4) ;
sns2=sfft(ns2,256,4) ;
[as bs]=s2a(ssp2,ns) ;
[an bn]=s2a(sns2,nn) ;

sp2=sp2(100:356) ;
ns2=ns2(100:356) ;
xm2=xm2(100:356) ;
snrpre=10*log10(sum((sp2).^2)/sum(ns2.^2)) 

figure(1) ;
A=ar2tm(as) ;
C=[zeros(1,ns-1) 1] ;
Q=zeros(ns) ; Q(ns,ns)=bs*bs ; r=sum(ns2.^2)/length(ns2) ;
cc=cputime ;y1=kalmanf(xm2,A,C,Q,r) ;
elapsed1=cputime-cc 
plot([y1' sp2 xm2]) ;
legend('Filter output','Speech','Filter input') ;
title('Unidirectional, white noise') ;
zoom on ;
filterr1=sum((y1-sp2').^2)
snrpost1=10*log10(sum((sp2').^2)/sum((y1-sp2').^2)) ;
snrimpr1=snrpost1-snrpre 

figure(2) ;
cc=cputime ; y2=kalmanr(xm2,A,C,Q,r) ;
elapsed2=cputime-cc
plot([y2' sp2 xm2]) ;
title('Bidirectional, white noise') ;
legend('Filter output','Speech','Filter input') ;
zoom on ;
filterr2=sum((y2-sp2').^2) 
snrpost2=10*log10(sum((sp2').^2)/sum((y2-sp2').^2)) ;
snrimpr2=snrpost2-snrpre 

figure(3) ;
[A,C,Q,r]=ard2tm(as,bs,an,bn) ;
cc=cputime ; ys=kalmanrs(xm2,A,C,Q,1e-6) ; 
elapsed3=cputime-cc
y3=ys(:,ns+nn)' ;
plot([y3' sp2 xm2]) ;
title('Bidirectional, colour noise') ;
legend('Filter output','Speech','Filter input') ;
zoom on ;
filterr3=sum((y3-sp2').^2) 
snrpost3=10*log10(sum((sp2').^2)/sum((y3-sp2').^2)) ;
snrimpr3=snrpost3-snrpre 

figure(4) ;
[A,C,Q,r]=ard2tm(as,bs,an,bn) ;
cc=cputime ; ys=kalmans(xm2,A,C,Q,1e-6) ; 
elapsed4=cputime-cc
y4=ys(:,ns+nn)' ;
plot([y4' sp2 xm2]) ;
title('Unidirectional, colour noise') ;
legend('Filter output','Speech','Filter input') ;
zoom on ;
filterr4=sum((y4-sp2').^2) 
snrpost4=10*log10(sum((sp2').^2)/sum((y4-sp2').^2)) ;
snrimpr4=snrpost4-snrpre 

figure(5) ;
t=1:length(sp2) ;
plot(t,sp2,'r',t,y1,'b',t,y2,'g',t,y3,'cyan',t,y4,'m',t,xm2,'black') ;
legend('Speech','Unidir','Bidir','Colour noise bi','Colour noise uni','Input') ;
title('Filter performance comparison') ;
zoom on ;




