disp('Demonstrate bidirectional Kalman filtering') ;
disp('We use real data and create models for both speech and noise') ;
load spsig4 ;
sp2=sp2(100:356) ;
ns2=ns2(100:356) ;
k=5 ;  % this controls the SNR   
ns2=k*ns2 ;

snrpre=10*log10(sum((sp2).^2)/sum(ns2.^2)) 

ns=16 ; nn=16 ;
xm2=ns2+sp2 ;
figure(1) ; plot([sp2 ns2 xm2]) ; title('Input') ;
legend('Speech','Noise','Mix') ;
zoom on ;

ssp2=sfft(sp2,256,4) ;
sns2=sfft(ns2,256,4) ;
[as bs]=s2a(ssp2,ns) ;
[an bn]=s2a(sns2,nn) ;

figure(2) ;
[A,C,Q,r]=ard2tm(as,bs,an,bn) ;
cc=cputime ; ys=kalmanrs(xm2,A,C,Q,1e-6) ; 
elapsed3=cputime-cc
y3=ys(:,ns+nn)' ;
plot([y3' sp2 xm2]) ;
title('Bidirectional, colour noise') ;
legend('Filter output','Speech','Filter input') ;
zoom on ;
snrpost3=10*log10(sum((sp2').^2)/sum((y3-sp2').^2)) ;
snrimpr3=snrpost3-snrpre 





