% This one estimates P matrixes from autocorrelation coefficients
disp('Demonstrate bidirectional Kalman filtering') ;
disp('We use real data and create models for both speech and noise') ;
load spsig4 ;
sp2=sp2(100:356) ;
ns2=ns2(100:356) ;
k=5 ;  % this controls the SNR   
ns2=k*ns2 ;

snrpre=10*log10(sum((sp2).^2)/sum(ns2.^2)) 

ns=16 ; nn=16 ;
xm2=ns2+sp2 ;
figure(1) ; plot([sp2 ns2 xm2]) ; title('Input') ;
legend('Speech','Noise','Mix') ;
zoom on ;

ssp2=sfft(sp2,256,4) ;
sns2=sfft(ns2,256,4) ;
[as bs cs]=s2ae(ssp2,ns) ;
[an bn cn]=s2ae(sns2,nn) ;

figure(2) ;
[A,C,Q,r,P]=ard2tme(as,bs,cs,an,bn,cn) ;
cc=cputime ; ys=kalmanrsi1(xm2,A,C,Q,r,P) ; 
elapsed=cputime-cc
y=ys(:,ns+nn)' ;
plot([y' sp2 xm2]) ;
title('Bidirectional, colour noise') ;
legend('Filter output','Speech','Filter input') ;
zoom on ;
snrpost=10*log10(sum((sp2').^2)/sum((y-sp2').^2)) ;
snrimpr=snrpost-snrpre 





