function P=dlyap2(A,Q) ;
% Solves iteratively Lyapunov equation P=A*P*A'+Q ;
%
% Usage: P=dlyap2(A,Q) ;

n=length(A) ;
P=ones(n) ;

Pold=2*P ;
i=1 ;
prec=1e-4 ;
maxiter=200 ;
miniter=20 ;

while i<maxiter & max(max(abs(P-Pold)))/(prec+max(max(abs(P))))>prec | i<miniter,
  Pold=P ;
  P=A*P*A'+Q ;
  i=i+1 ;
end ; 

