function [d,l]=dyadr(d,l)
% Performs dyadic reduction to keep l*diag(d)*l'
% and to restore the lower triangular monic matrix

n=length(d) ;
for i=1:n,
  lii=l(i,i) ;
  if (abs(lii)<1e-50),
    error('Component on the diagonal is too small.') ;
  end ;
 
  l(:,i)=l(:,i)/lii ;
  d(i)=d(i)*lii*lii ; 
%  i,d,l,l*diag(d)*l'  
  
  for j=n:-1:i+1,
     lij=l(i,j) ;
     div=d(i)+lij^2*d(j) ;
     if (abs(div)>1e-50), 
       djv=d(j)/div*d(i) ; 
       u=d(j)/div*lij ;
     else u=0 ; 
     end ;
     l(:,j)=l(:,j)-lij*l(:,i) ;
     l(:,i)=l(:,i)+u*l(:,j) ;
     d(i)=div ;
     d(j)=djv ;
  end ;
end ; 
        