function [y,knew]=fltsgonc(x,n,k) ;
% Filter segment once
% Takes a segment x of the noisy input signal, estimates parameters
% of its ARX model and the noise covariance and applies Kalman
% filter to obtain the filtered signal y
% n is the order of the system
% k,knew is the initial resp. final Kalman gain
% Usage: [y knew]=fltsgonc(x,k,n) ;
% Jan Kybic, 14.3.1997
% changed 22.4.1997 

T=length(x) ;

% Estimate ARX parameters through autocorrelation
a=clhame(x,n) ;


% Filter, adaptively find the correct Kalman gain
[y e knew]=kalmkee(x,ar2tm(a),k) ;

if iswhite(e)<1, % not white?
   a=clham(x,n) ;
   [y e knew]=arxoekal(x,ar2tm(a),knew) ;
end ;



