function [q,r]=getnoise(c,a)
% Given autocorrelation coefficients c and AR model coefficients a
% this function attempts to estimate the measurement noise r and the 
% process noise q energies
% Usage: [q,r]=getnoise(c,a)

c=c(:) ;
m=length(c) ;
cr=a2c(a,m) ; % generate reference autocorrelation coefs.
M= ([ 1 zeros(1,m-1) ; cr' ])' ;
qr=M \ c ;
q=qr(2) ; r=qr(1) ;