function sn=getpss(x)
% This function estimates the power spectrum of the signal
% Usage: sn=getpss(x)

% Set some constants first
w=256   ; % window length, should be power of two
ovrf=4  ; % overlap factor

% Algorithm parameters - original
% alpha=0.7 ;
% beta=0.96 ;
% gamma=0.998 ;
alpha=0.5 ;

s=w/ovrf ; % window shift

x=x(:)' ;
T=length(x) ;

cnt=floor((T-w)/s) ; % how many windows
h=hanning1(w) ;       % window weights
h=w/ovrf/sum(h)*h ;  % adjust to proper scaling


x=x-sum(x)/T ;       % remove the mean
sps=zeros(1,w/2) ;     % smoothed power spectrum
spsold=sps ;
nps=zeros(1,w/2) ;     % noise estimate power spectrum

sn=zeros(cnt+1,w/2) ;
for i=0:cnt,                  % cycle over windows
 ind1=1+i*s ; ind2=w+i*s ;    % start and end indexes
% disp(['Frame ',num2str(i)]) ;
 xw=x(ind1:ind2) ;            % cut out the window
 sp=fft(xw) ;
 sp=sp(1:w/2) ;               % cut out the symetric half
 sp=sp.*conj(sp) ;            % we have the power spectrum here
 sps=alpha*sps+(1-alpha)*sp ; 
 sn(i+1,:)=sps ;
end ; 
 



