function a=htls(x,n) ;
% Hankel Total Least Squares based AR model parameter estimation
%
% 'x' containts measurements corrupted by white noise
% on output 'a' contains the coefficients of an AR system of the order 'n'
% generating output 'y', while (x-y) is minimised in Euclidean sense
% y(i)=a(1)*y(i-1)+a(2)*y(i-2)+...+a(n)*y(i-n)
% a=arg min sum((y(i)-x(i))^2)
%
% Usage: a=htls(x,n) ;

x=x(:) ;
T=length(x) ;
l=floor(T/2) ;  % number of rows
m=T+1-l ;     % number of columns of the Hankel matrix

% construct the matrix
X=zeros(l,m) ;
for i=1:l,
  X(i,:)=x(i:i+m-1)' ;
end ;

[u s v]=svd(X,0) ;
z=tls(u(1:l-1,1:n),u(2:l,1:n)) ;
% z=u(1:l-1,1:n)\u(2:l,1:n) ;
e=eig(z) ;
for i=1:n,
  if abs(e(i))>1, 
    e(i)=1 ;
  end ;
end ;
  
a=poly(e) ;
a=-a(2:n+1) ;