function [a, b]=idarxb(y,n)
% Identifies ARX model of the n-th order using data y
% uses forward/backward method supplied in ar  - one time identification
% returns vector of n a coefficients and the b coefficient
% Usage: [a b]=idarxb(y,n)

a=th2poly(ar(y,n)) ;
a=-a(2:n+1) ; % ar uses a different conventions than we do

% The following is less accurate than the alternative method
% c=corrn(y,n+1)' ;
% b=sqrt(sum(c.*[1 -a])) ;

% here is the old version
%a=idarx(y,n) ;

c=sum(y.^2)/length(y) ;
%% This would be done quicker directly
b=sqrt(getnoise(c,a)) ;




