function [a,q,r]=idarxoe(y,n)
% Identifies ARX model of the n-th order using data y
% uses LSM - one time identification
% returns vector of n a coefficients
% q is the process noise dispersion estimate
% r is the measurement noise dispersion estimate

 T=length(y) ;
 z=zeros(T-n,n) ;
 b=y(n+1:T) ;
 for i=1:T-n,
  for j=1:n, z(i,j)=y(i-j+n) ; end ;
    b(i)=y(i+n) ;
 end ;
 a=b*pinv(z)' ;


 ye=a*z' ;  % estimated output
 yi=b-ye ; % inovative sequnce
 cv=xcorr(yi,'biased') ; cv=cv(1:n) ;    % auto-covariance
 l=zeros(n,2) ;
 for i=1:n-1,
   l(i,1)=-a(i) ;
   l(i,2)=a(1:n-i)*a(i+1:n)' ;
 end ;
 l(n,1)=-a(n) ; ar=l\cv ;
 r=sqrt(abs(ar(2))) ; q=ar(1)/r-r ;
 if (q<0), q=0 ; end ;
 r=sqrt(r) ; q=sqrt(q) ;
end ;



