function r=iswhite(y)
% This function determines according to the autocorrelation
% test proposed by Mehra, whether a given sequence y is
% white. Results r>1 means white, r<1 nonwhite
% Usage: r=iswhite(y) ;
% It is necessarily slow :-)


T=length(y) ;
cr=corrn(y,T) ;
c=cr(2:T)/cr(1) ;
c=abs(c) ;

lmt=1.96/sqrt(T-1) ; % confidence limits for 95%
r=0 ;
for i=1:T-1,
  if c(i)>lmt, r=r+1 ; end ;
  end ;
r=r/(T-1) ;
if r==0, r=0.001 ; end ; % to avoid division by zero
r=0.05/r ;   % 5% of c are allowed to be outside the limits



