function k=kgain(A,q)
% Determines optimal steady-state Kalman gain
% 'A' is the system matrix and q is the process noise/measurement noise ratio
% Usage: k=kgain(A,q)

n=length(A) ;

% Unstable ?
if max(abs(roots(poly(A))))>1, 
  error('System matrix is unstable') ;
end ;

prec=1e-6 ;   % the desired precision

P=eye(n) ;
Pold=P+eye(n) ;
%iter=0 ;

while max(max(abs(P-Pold)))>prec ;
      Pold=P ;	
%     P=A*(P-P*h'*inv(h*P*h'+1)*h*P)*A'+h*q*h' ;
      P=A*(P-P(:,n)/(P(n,n)+1)*P(n,:))*A' ;
      P(n,n)=P(n,n)+q ;
%     iter=iter+1 ;
      end ;
%   P
% iter

k=(P(:,n)/(P(n,n)+1))' ;






