function [DD,LLT] = ldfaktor(Matice)
% For a symetrical matrix M, finds vector d and upper triangular
% matrix L, such that L'*diag(d)*L=M
% Usage [d,L]=ldfaktor(M) 

nld = length(Matice);
DD = zeros(nld,1);
LLT = eye(nld);
for ild=1:nld;
  pomld = 0;
  for jld=1:ild-1;
    pomld = pomld + DD(jld)*LLT(ild,jld)*LLT(ild,jld);
  end;
  DD(ild) = Matice(ild,ild)-pomld;
  for jld=ild+1:nld;
    pomld = 0;
    for kld=1:ild-1;
      pomld = pomld + DD(kld)*LLT(jld,kld)*LLT(ild,kld);
    end;
    LLT(jld,ild) = (Matice(jld,ild) - pomld)/DD(ild);
  end;
end;
LLT = LLT';
