function sig=loadwav(filename,channels,length);
% Function LOADWAV: loading of WAV-formated signal to vector
%
% Usage: sig=loadwav(filename[,channels,length]);
%   filename   - name of WAV-file with signal
%
% Optional parameters:                                             <Defualt values>
%   channels   - number of signal channels                                    <1>
%   length     - desired length of loaded signal     <according length of signal>
%
% Output:
%   sig        - output vector/matrix (format as follows)
%             s1(1),   s2(1),  ...,  sn(1),
%             s1(2),   s2(2),  ...,  sn(2),
%             s1(3),   s2(3),  ...,  sn(3),
%               :        :      :      : 
%             1-st.,   2-nd.,   :    n-th channel
 
%                              Made by PP
%                            28 March 1995
%                           CTU FEL,  Prague



if nargin==1,
  channels=1;
  length=inf;
elseif nargin==2,
  length=inf;
end;

if nargin>3,
  disp('Error: Too many parameters of loadwav !');
  return;
end;

F=fopen(filename,'r');
if F==-1,
  disp('Error: Enable to open signal !');
  return;
end;

fseek(F,44,-1);    % skip over head of wav file

[sig,count]=fread(F,length,'short');

disp(sprintf('%.0f samples were read!',count));

fclose(F);

sig=sig(:);
sig=chshape(sig,channels);
