function e=mlaroefn1(r,a,z,dispf)
% Compute the prediction error function
% r is log10 of the relative output measurement error dispersion
% Usage e=mlaroefn1(r,a,z,dispf)


if nargin<4, dispf=0 ; end ;

n=length(a) ;
T=length(z) ;
%q=a(n+1) ;
a=a(1:n) ; 
A=ar2tm(a) ;
q=1 ; r=10^r ;
h=[ zeros(1,n-1) 1] ; % output vector h 
   P=eye(n) ;
   k=P(:,n)/(P(n,n)+r) ;
   kold=k+ones(n,1) ;
   iter=0 ; maxiter=2000 ;
   while max(abs(k-kold))>1e-6 & iter<maxiter,
      Pold=P ; iter=iter+1 ;
%     P=A*(P-P*h'*inv(h*P*h'+r)*h*P)*A'+h*q*h' ;
      P=A*(P-P(:,n)/(P(n,n)+r)*P(n,:))*A' ;
      P(n,n)=P(n,n)+q ;
      kold=k ; k=P(:,n)/(P(n,n)+r) ;
      end ;
%   P
if iter>=maxiter, 	
	disp('mlaroefn1: Maximum number of iterations reached.') ;
%        pause ;
end ;

% k now contains the Kalman gain
% find the optimal starting estimate x0 so as to minimize the total errors 
M=zeros(T,n) ; % M*x0-p = err
p=zeros(T,1) ;   % the right side of the equation
yhat=zeros(T) ;
w=eye(n) ;    % the actual estimate
wa=zeros(n,1) ;         % the absolute factor     
IK=zeros(n) ; IK(:,n)=k ; IK=A*(eye(n)-IK) ;
for i=1:T,
  M(i,:)=-w(n,:) ; p(i)=wa(n) ; 
  % Compute y(k|k-1) -> y(k+1|k)
  wa=A*(wa+k*(z(i)-wa(n))) ;
  w=IK*w ;  
  end ;
p=z'-p ;

% x0=M \ p ;
% To get rid of the warnings

[U,S,V]=svd(M,0) ;

ms=max(diag(S))*1e-12 ;
for i=1:n, 
  if S(i,i)>ms, S(i,i)=1/S(i,i) ; 
           else S(i,i)=0 ;
  end ;
end ;

x0=V*S*U'*p ;

d=p-M*x0 ; yhat=z'-d ;
e=sum(d.*d) ;
if dispf, 
   clf ;
%   plot([yhat z']) ; zoom on ;
%   legend('Predikce','Vystup') ;
plot(yhat(100:300)) ; zoom on ;
end ;


  









