function [a,b]=s2a(s,n)
% Given a symetrical (full-length) power spectrum s, this function
% estimates the a and b parameters of an appropriate white noise driven 
% AR model.
% Usage: [a b]=s2a(s,n) ;

N=length(s) ;
% Compute the autocorrelation, we omit dividing by N for simplicity
% see ps2c
c=real(ifft(s)) ;
c=c(1:N/2) ; % the other half is symetrical, better truncate it

% various approaches can be taken to estimate a
% a=c2ach(c,n) ;
% a=th2poly(ar(c,n,'burg')) ;
% a=-a(2:n+1) ;
a=burg1(c,n) ;


sa=a2s(a,N) ;
b=sqrt(sum(s)/sum(sa.^2)) ;