function [a,b,c]=s2aex(s,n)
% Given a symetrical (full-length) power spectrum s, this function
% estimates the a and b parameters of an appropriate white noise driven 
% AR model. c is the autocorrelation calculated as a by product
% This version uses TSTLS estimate of the parameters
% Usage: [a b]=s2aex(s,n) ;

N=length(s) ;
% Compute the autocorrelation, we omit dividing by N for simplicity
% see ps2c
c=ps2c(s,N/2) ; % the other half is symetrical, better truncate it

% various approaches can be taken to estimate a
% a=c2ach(c,n) ;
% a=th2poly(ar(c,n,'burg')) ;
% a=-a(2:n+1) ;

%a=burg1(c,n) ;
a=tstlswc(c,n,100) ;

sa=a2s(a,N) ;
b=sqrt(abs(sum(s)/sum(sa.^2))) ;
% b=getnoise(c,a)
% b=sqrt(abs(b))  ;
c=c(1:n) ;