function x=sarmax(a,b,c,u)
% Simulates stochastical ARMAX system with parameters a,b,c 
% and deterministic input u
% Usage x=sarmax(a,b,c,u)  
u=u(:)' ;
T=length(u) ; % number of samples
na=length(a) ; % order of the system

nb=length(b) ;

nc=length(c) ;


% Reverse and transpose the vectors

arev=a(na:-1:1)' ;

brev=b(nb:-1:1)' ;

crev=c(nc:-1:1)' ;

% Make an extended 'white noise' input vector
prl=max([na nb nc]) ;
ee=randn(1,T+prl) ;

% Extend the state history vector and the input vector
xe=zeros(prl+T) ;
xu=[zeros(1,prl) u] ;

% Simulate
for k=1:T,
   xe(k+prl)=xe(k+prl-na:k-1+prl)*arev+xu(k+prl-nb+1:k+prl)*brev ...
       +ee(k+prl-nc+1:k+prl)*crev ;
   end ;

% Cut the leading part of the resulting vector
x=xe(prl+1:T+prl) ;

 




