function sp=sfft(x,n,ovr)
% Computes a smoothed periodogram of the length n from signal x
% with overlap factor ovr
% Usage: sp=sfft(x,n,ovr) 

x=x(:)' ;
s=n/ovr ;
N=length(x) ;
cnt=floor((N-n)/s) ;
% Windowing currently not used
h=hanning1(n)' ;
h=h * n / sum(h)  ; % Compensate for the bias
sp=zeros(1,n) ;
for i=0:cnt,
  sp=sp+abs(fft(x(i*s+1:i*s+n))).^2 ;
%  sp=sp+abs(fft(x(i*s+1:i*s+n).*h)).^2 ;
end ;
 
sp=sqrt(sp/(cnt+1)) ;
