function x=subr(z,y,q) ;
% Given power spectral magnitude estimate z, obtained as an average of q
% periodograms and precise power spectral magnitude y, calulate approximate
% MS estimate of x=z-y 
%
% Usage: x=subr(z,y,q) ;

x=z ;
for i=1:length(z),
  zz=z(i) ; yy=y(i) ;
  if zz==0, xx=0 ;
  else
    m=zz-yy ; s=zz/q ;
    t=-m/s ;
    if (t>pi/2), xx=0 ;
    else 
      lb=max(t,-pi/2) ;
      xx=s*((pi/2-t)-((lb-t)*sin(lb)+cos(lb)))/(1-sin(lb)) ;
    end ;
  end ;
  x(i)=xx ;
end ;

      