function x=tls(a,b)
% Solves generic Total Least Square Problem a*x=b
%
% Usage: x=tls(a,b) ;

[m n]=size(a) ;
[m1 d]=size(b) ;

if m~=m1, 
  error('Matrices a and b must have the same number of rows') ;
end ;

[u s v]=svd([a b],0) ;

z=v(1:n,n+1:n+d) ;
g=v(n+1:n+d,n+1:n+d) ;
x=-z/g ;
