function a=x2a(x,n) 
% Given a signal x,  this function computes the 'a'
% parameters of an AR synthetising filter of the order n
% It uses normal equations derived from Cayley-Hamilton theorem
% Usage: a=x2a(x,n)

% The length of the input vector
T=length(x) ;
if (2*n>=T), error('The signal is too short.') ; end ;

% Here corrn can be replaced by corrs
c=corrn(x,2*n+1) ;

% c2ache, c2ach alternatively
a=c2ache(c,n) ;
a=astab(a) ;









