function a=x2ar(x,n) 
% Given a signal x,  this function computes the 'a'
% parameters of an AR synthetising filter of the order n
% It uses normal equations derived from Cayley-Hamilton theorem
% It differs from x2a in that it uses repetitive autocorrelation
% Usage: a=x2ar(x,n)

% The length of the input vector
T=length(x) ;
m=max(2*n+1,1000) ;  % We shall use this many coefficients
m=min(m,T) ;

if (m>T), error('The signal is too short.') ; end ;

w=ones(m,1) ; %initial weights

iter=7 ; % Number of iterations

if 0,    % 1 to use corrn instead of corrs

for j=1:iter,
 x=corrn(x,m+1-j) ; % 
 x=x(2:m+1-j) ; x=x/max(abs(x)) ; % scaling seems necessary
 w=corrn(w,m+1-j) ;
 w=w(2:m+1-j) ; w=w/max(w) ; 
 if 1, % compute on the way
   c2achw(x,w,n) 
 end ;
end ; % of for j

a=c2achw(x,w,n) ;

else

for j=1:iter,
 x=corrs(x,m+1-j) ; % 
 x=x(2:m+1-j) ; x=x/max(abs(x)) ; % scaling seems necessary
 if 0, % compute on the way
   c2ache(x,n) 
 end ;
end ; % of for j

a=c2ache(x,n) ;

end ;

a=astab(a) ;




